import numpy
import torch
from torch import nn
from collections import OrderedDict

def GEV(x):
	return torch.exp(-torch.exp(-x))

class my_FCL(nn.Module):
    def __init__(self, in_dim, out_dim):
        super(my_FCL, self).__init__()
        self.w = nn.Parameter(torch.randn(in_dim, out_dim))
        self.b = nn.Parameter(torch.randn(out_dim))

    def forward(self, x):
    	return x @ self.w + self.b

class Net(nn.Module):
	def __init__(self, in_dim):
		super().__init__()

		# self.weight = nn.Sequential(OrderedDict([
 		# ('hidden', nn.Linear(in_dim, 32)),
 		# ('linear', nn.Linear(32, in_dim))
 		# ]))
 		
		self.weight_hidden = nn.Linear(in_dim, 32)
		self.weight_output = nn.Linear(32, in_dim)

		self.coder_layer1 = nn.Linear(in_dim, 32)
		self.coder_layer2 = nn.Linear(32, 16)
		self.coder_layer3 = nn.Linear(16, 8)
		self.coder_layer4 = nn.Linear(8, 16)
		self.coder_layer5 = nn.Linear(16, 32)
		self.coder_layer6 = nn.Linear(32, in_dim)
		self.coder_layer7 = nn.Linear(in_dim, 32)
		self.coder_layer8 = nn.Linear(32, 16)
		self.coder_layer9 = nn.Linear(16, 8)

		self.pre_hidden = my_FCL(in_dim * 2 + 16, 32)
		self.pre_output = nn.Linear(32, 1)

	def forward(self, x):
		x_1 = x.clone()
		x_1_0 = x_1.clone()
		x_1 = self.weight_hidden(x_1)
		x_1 = self.weight_output(x_1)
		x_1 = nn.functional.softmax(x_1, dim = 1)
		x_1 = x_1 * x_1_0

		x_2 = x.clone()
		x_2_0 = x_2.clone()
		x_2 = self.coder_layer1(x_2)
		x_2 = self.coder_layer2(x_2)
		x_2 = self.coder_layer3(x_2)
		#x_2 = torch.sigmoid(x_2)
		z_1 = x_2.clone()
		z_out = z_1.clone()
		x_2 = self.coder_layer4(x_2)
		x_2 = self.coder_layer5(x_2)
		x_2 = self.coder_layer6(x_2)
		#x_2 = torch.sigmoid(x_2)
		x_2_1 = x_2.clone()
		x_2 = self.coder_layer7(x_2)
		x_2 = self.coder_layer8(x_2)
		x_2 = self.coder_layer9(x_2)
		#x_2 = torch.sigmoid(x_2)
		z_2 = x_2.clone()
		x_dist = torch.pow((x_2_1 - x_2_0) * (x_2_1 - x_2_0), 0.5)
		z_dist = torch.pow((z_1 - z_2)*(z_1 - z_2),0.5)

		x_3 = torch.cat((x_1,z_dist,x_dist,z_out), 1)
		FCL = x_3.clone()
		x_3 = self.pre_hidden(x_3)
		x_3 = self.pre_output(x_3)
		x_3 = GEV(x_3)
		#x_3 = torch.sigmoid(x_3)

		return x_2_1, x_3.view(-1), z_1,z_2,FCL
