
import torch
import torch.nn as nn
class generator(nn.Module):
    def __init__(self):
        super(generator, self).__init__()
        self.gen = nn.Sequential(
            nn.Linear(100, 256),  # Map input to 256 dimensions with linear transformation
            nn.ReLU(True),  # Relu activation
            nn.Linear(256, 512),  # Linear transformation
            nn.ReLU(True),  # Relu activation
            nn.Linear(512, 784),  # Linear transformation
            nn.Tanh()  # Tanh activation makes the generated data distributed between [- 1,1], because the input real data is also distributed after the transformation
        )
 
    def forward(self, x):
        x = self.gen(x)
        return x
 