import numpy
import torch
from torch import nn


def GEV(x):
    return torch.exp(-torch.exp(-x))

class my_FCL(nn.Module):
    def __init__(self, in_dim, out_dim):
        super(my_FCL, self).__init__()
        self.w = nn.Parameter(torch.randn(in_dim, out_dim))
        self.b = nn.Parameter(torch.randn(out_dim))

    def forward(self, x):
        return x @ self.w + self.b

class predict_nn(nn.Module):
    def __init__(self,in_dim):
        super().__init__()
        self.pre_hidden = my_FCL(in_dim * 2 + 16, 32)
        #self.hidden1 = nn.Linear(in_dim*2+16,32)
        #self.hidden2 = nn.Linear(32,16)
        self.output = nn.Linear(32, 1)


    def forward(self,x):
        #x = self.hidden1(x)
        #x = self.hidden2(x)
        x = self.pre_hidden(x)
        x = self.output(x)
        x = GEV(x)
        return x.view(-1)
